import {
  select,
  csv,
  scaleLinear,
  scaleOrdinal,
  extent,
  axisLeft,
  axisBottom,
  format
} from 'd3';
import { colorLegend } from './colorLegend';
import { dropdownMenu } from  './dro
      selectedOption: xAxisColumn
    });
  
  select('.ySelect')
    .call(dropdownMenu, {
      options: columns,
      onOptionClicked: y => {
        yAxisColumn = y;
        render(data);
      },
      selectedOption: yAxisColumn
    });
  
  const xScale = scaleLinear()
    .domain(extent(data, xValue))
    .range([0, innerWidth])
    .nice();
  
  const yScale = scaleLinear()
    .domain(extent(data, yValue))
    .range([innerHeight, 0])
    .nice();
  
  svg.selectAll('g').remove();
  
  const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);
  
  const xAxis = axisBottom(xScale)
    .tickSize(-innerHeight)
    .tickPadding(15);
  
  const yAxis = axisLeft(yScale)
    .tickSize(-innerWidth)
    .tickPadding(10);
  
  const yAxisG = g.append('g').call(yAxis);
  yAxisG.selectAll('.domain').remove();
  
  yAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', -93)
      .attr('x', -innerHeight / 2)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .attr('text-anchor', 'middle')
      .text(yAxisLabel);
  
  const xAxisG = g.append('g').call(xAxis)
    .attr('transform', `translate(0,${innerHeight})`);
  
  xAxisG.select('.domain').remove();
  
  xAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', 75)
      .attr('x', innerWidth / 2)
      .attr('fill', 'black')
      .text(xAxisLabel);
  
  g.selectAll('circle').data(data)
    .enter().append('circle')
      .attr('class', 'circle')
      .attr('cy', d => yScale(yValue(d)))
      .attr('cx', d => xScale(xValue(d)))
      .attr('r', circleRadius)
      .attr('fill', d => colorScale(d.origin))
  	  .attr('opacity', d => {
    	if (selectedCountry == null) return '0.3'
    	else if (selectedCountry == d.origin) return '0.4'
    	return '0.1'
      })
    .append('title')
      .text(d => d.origin + ': ' + d.name);
  
  const colorLegendG = svg.append('g')
      .attr('transform', `translate(740,200)`);
  
  colorLegendG.call(colorLegend, {
    colorScale,
    circleRadius: 8,
    spacing: 20,
    textOffset: 12,
    backgroundRectWidth: 120,
    onClick: d => {
      selectedCountry = (selectedCountry == d ? null : d);
      render(data);
    }
  });
};

csv('https://vizhub.com/curran/datasets/auto-mpg.csv')
  .then(data => {
    data.forEach(d => {
      d.mpg = +d.mpg;
      d.cylinders = +d.cylinders;
      d.displacement = +d.displacement;
      d.horsepower = +d.horsepower;
      d.weight = +d.weight;
      d.acceleration = +d.acceleration;
      d.year = +d.year;  
    });
    render(data);
  });